package com.exceleg.poi312beta2.delete;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class ExcelTasksHelper {

	public static XSSFSheet returnSheet(XSSFWorkbook wb, int sheetNo) {
		XSSFSheet currentSheet=wb.getSheetAt(sheetNo);
		return currentSheet;
	}

	public static XSSFWorkbook returnWorkbookForGivenDoc(String docName) {
		//File f = new File(docName);
		XSSFWorkbook wb = null;
		try {
			InputStream is=ExcelTasksHelper.class.getResourceAsStream(docName);
			if(is==null) {
				System.out.println("Input stream is null");
			}
			wb=new XSSFWorkbook(is);
			is.close();
		} catch (FileNotFoundException e) {
			 throw new RuntimeException("Given file "+docName+" is not found. Make sure it is in the correct folder");
		} catch (IOException e) {
			throw new RuntimeException("Exception while opening file "+docName);
		}
		return wb;
	}

	public static String replaceCustomTokenInFormulaString(String formulaString, String customToken, String replacement) {
	    int startSearchFrom=0;
	    boolean foundCorrectSubstr=false;
	    System.out.println("formula string length "+formulaString.length());
	    System.out.println("custom token length = "+customToken.length());
	    int origStrLen=formulaString.length();
	    int customTokenLen=customToken.length();
	    while(startSearchFrom!=-1) {
	        startSearchFrom=formulaString.indexOf(customToken, startSearchFrom);
	        System.out.println("start value "+startSearchFrom);
	        if(startSearchFrom==-1) { //useful only in the first run of while loop
	            continue;
	        } else {
	            Character charBefore=null;
	            if(startSearchFrom!=0) {
	            	charBefore=formulaString.charAt(startSearchFrom-1); //get character before customToken substring in formulaString string
	            }
	            Character charAfter=null;
	            if((startSearchFrom+customTokenLen) < origStrLen) {
	            	charAfter=formulaString.charAt(startSearchFrom+customToken.length()); // get character after customToken substring in formulaString string
	            }
	            if(charBefore!=null && Character.isLetterOrDigit(charBefore) || (charAfter!=null && Character.isLetterOrDigit(charAfter))) { //this occurance is not what we need to replace
	                startSearchFrom+=customToken.length(); //update index to start searching again in formulaString.
	            } else {
	                foundCorrectSubstr=true;
	                break;
	            }
	        }
	    }
	    if(foundCorrectSubstr) {
	        StringBuilder fsb=new StringBuilder();
	        fsb.append(formulaString.substring(0, startSearchFrom));
	        fsb.append(replacement);
	        if(startSearchFrom==(formulaString.length()-1)) {
	        	//do nothing
	        } else {
	        	fsb.append(formulaString.substring(startSearchFrom+customToken.length(), origStrLen));
	        }
	        formulaString=fsb.toString();
	    }
	    return formulaString;
	}

	public static void main(String args[]) {
		String origString="(AAA:AAAA)/AA";
		String str2="(BAB-BAC)/(AC)";
		System.out.println(replaceCustomTokenInFormulaString(origString, "AA", "BB"));
	}

}
