package com.exceleg.poi312beta2.test;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.apache.poi.ss.usermodel.Comment;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.junit.Test;

import com.exceleg.poi312beta2.delete.ExcelTasksHelper;

public class ShowShiftRowsWithCommentsBugTest {

	@Test
	public void bugOnlyOneCommentShiftedInRow() {
		XSSFWorkbook wb=ExcelTasksHelper.returnWorkbookForGivenDoc("/resources/deletewithcomments.xlsx");
		XSSFSheet sheet=ExcelTasksHelper.returnSheet(wb,0);
		Comment comment1 = sheet.getCellComment(2, 1);
		assertNotNull(comment1);

        Comment comment2 = sheet.getCellComment(2, 2);
		assertNotNull(comment2);

        Comment comment3 = sheet.getCellComment(1, 1); //(NO comment in (1,1) and it should be null)
        assertNull(comment3);

        sheet.shiftRows(2, 2, -1);

        comment3 = sheet.getCellComment(1, 1); //Comment in (2,1) moved to (1,1) so its not null now.
        assertNotNull(comment3);

        comment1 = sheet.getCellComment(2, 1); // No comment currently in (2,1) and hence it is null
        assertNull(comment1);

        comment2 = sheet.getCellComment(2, 2); // Comment in (2,2) should have moved as well because of shift rows.
        assertNull(comment2); // as long this bug exists in POI, this will fail
	}

}
